diff --git a/scheme/bot-wander.scm b/scheme/bot-wander.scm
new file mode 100644
index 0000000..730670c
--- /dev/null
+++ b/scheme/bot-wander.scm
@@ -0,0 +1,647 @@
+(use-modules
+ (srfi srfi-1)  ;; List functions (reduce, fold, alist-*, ...)
+ (srfi srfi-69) ;; Hash Table
+ )
+
+;;;;;;;;;;;;;;;;
+;; Helper Output Functions
+
+(define (map-info-print map-info)
+  (define (map-coords-list x-min x-max y-min y-max)
+    (define (iter x y accum)
+      (cond
+       ((< y y-min) accum)
+       ((< x x-min) (iter x-max (- y 1) accum))
+       (else (iter (- x 1) y (cons (list x y) accum)))))
+    (iter x-max y-max '()))
+  (define (loc-chars coords)
+    (let*
+	((loc-info (hash-table-ref/default map-info coords #f))
+	 (map-display-alist
+	  '(("space" . ".") ("food" . "+") ("prize" . "$")
+	    ("wall" . "#") ("baddie" . "@") ("robot" . "R")))
+	 (map-display-bot-alist ;; Info the robot added to the map
+	  '((not-visited . "?") (robot . "R") (inferred . "i")))
+	 (loc-type (and loc-info (assoc (car loc-info) map-display-alist)))
+	 (loc-bot-data (assoc (and loc-info (cadr loc-info)) map-display-bot-alist)))
+      (list (if loc-info (or (and loc-type (cdr loc-type)) "!") "*")
+	    (if loc-info (or (and loc-bot-data (cdr loc-bot-data)) " ") " "))))
+  (let
+      ((map-dims ;; x and y max and min
+	(fold
+	 (lambda (b a)
+	   (list (cons 'min-x (min (cdr (assoc 'min-x a)) (car  b)))
+		 (cons 'max-x (max (cdr (assoc 'max-x a)) (car  b)))
+		 (cons 'min-y (min (cdr (assoc 'min-y a)) (cadr b)))
+		 (cons 'max-y (max (cdr (assoc 'max-y a)) (cadr b)))))
+	 '((min-x . 0) (max-x . 0) (min-y . 0) (max-y . 0))
+	 (hash-table-keys map-info))))
+    (format #t "~A~%" map-dims)
+    (for-each
+     (lambda (c)
+       (if (= (car c) (cdr (assoc 'min-x map-dims)))
+	   (newline))
+       (let*
+	   ((loc-ch (loc-chars c)))
+	 (format #t "~1A~1A" (car loc-ch) (cadr loc-ch))))
+     (map-coords-list
+      (cdr (assoc 'min-x map-dims))
+      (cdr (assoc 'max-x map-dims))
+      (cdr (assoc 'min-y map-dims))
+      (cdr (assoc 'max-y map-dims))))
+    (newline)))
+
+(define (shortest-paths-print sp)
+  (let
+      ((min-vals (apply map min (hash-table-keys sp)))
+       (max-vals (apply map max (hash-table-keys sp))))
+    (format #t "Dims: (~d, ~d) -> (~d, ~d)~%"
+	    (car min-vals)  (car max-vals)
+	    (cadr min-vals) (cadr max-vals))
+    (for-each
+     (lambda (y)
+       (when (= y (cadr min-vals)) ;; Print x headings
+	 (format #t "     ")
+	 (for-each
+	  (lambda (x) (format #t "~4d  " x))
+	  (iota (1+ (- (car max-vals) (car min-vals))) (car min-vals)))
+	 (newline))
+       (format #t "~3d: " y) ;; Print y headings
+       (for-each
+	(lambda (x)
+	  (let
+	      ((north-south
+		(hash-table-ref/default sp (append (list x y) '(0 1)) #f))
+	       (east-west
+		(hash-table-ref/default sp (append (list x y) '(1 0)) #f)))
+	    (format #t "~4d~1A~1A"
+		    (reduce min -2
+			    (filter number? (list north-south east-west)))
+		    (if (and north-south
+			     (or (not east-west)
+				 (>= east-west north-south)))
+			"N" " ")
+		    (if (and east-west
+			     (or (not north-south)
+				 (>= north-south east-west)))
+			"E" " "))))
+	(iota (1+ (- (car max-vals) (car min-vals))) (car min-vals)))
+       (newline))
+     (iota (1+ (- (cadr max-vals) (cadr min-vals))) (cadr min-vals)))))
+
+;;;;;;;;;;;;;;;;
+;; Core Bot Logic
+
+;; Cardinal Directions are lists (x y) where the value in x and y are
+;; the offsets to use from the current position to reach the
+;; coordinate one away in that direction.
+
+;; All the directions in sequence so that clockwise turns will produce
+;; the next in the seq.
+(define directions-in-seq
+  '(( 1  0)
+    ( 0  1)
+    (-1  0)
+    ( 0 -1)))
+;; A clockwise circular (endless) representation of directions
+(define circular-directions
+  (apply circular-list directions-in-seq))
+
+;; Given a direction dir, turn-clockwise gives the cardinal direction
+;; for a 90 degree clockwise turn.
+(define (turn-clockwise dir flip)
+  (let
+      ((dir-n (find-tail
+	     (lambda (x) (equal? x dir))
+	     ((if flip reverse (lambda (l) l))
+	      (take circular-directions
+		    (1+ (length directions-in-seq)))))))
+    (if dir-n
+	(cadr dir-n)
+	;; This error should never happen; function handles this and
+	;; writes an error message to prevent an infinite loop.
+	(error turn-clockwise "unmatched dir given" dir))))
+
+;; Calculate the turns to turn to face dest-coords originating from
+;; coords and facing dir.
+;; coords and dest-coords must be adjacent (if they are not, returns
+;; #f).
+;; Returns negative numbers for counter-clockwise turning and positive
+;; numbers for clockwise turning.
+(define (turns-to-face coords starting-dir dest-coords)
+  (define (iter dir turns)
+    (cond
+     ((equal? (map + coords dir) dest-coords) turns)
+     ((> turns (length directions-in-seq))
+      (error (format #f "turns-to-face: coords ~A and ~A are not adjacent~%" coords dest-coords))
+      #f)
+     (else
+      (iter (turn-clockwise dir #f) (1+ turns)))))
+  (let
+      ((turns (iter starting-dir 0)))
+    (cond
+     ((not turns) #f)
+     ((> turns (abs (- turns (length directions-in-seq))))
+      (- turns (length directions-in-seq)))
+     (else turns))))
+
+(define (bot-turn starting-dir turns)
+  (cond
+   ((zero? turns) starting-dir)
+   (else
+    (let
+	((one-turn (if (> 0 turns) -1 1)))
+     (if (robot-turn one-turn)
+	 (bot-turn (turn-clockwise starting-dir (> 0 one-turn))
+		   (- turns one-turn))
+	 starting-dir)))))
+
+;; Perform a turn to a dest-coord requiring the fewest number of
+;; turns.
+;; Returns the new direction the robot is facing.
+(define (turn-to-best coords starting-dir dest-coords-list)
+  (cond
+   ((null? dest-coords-list) starting-dir)
+   (else
+    (let
+	((best-coords
+	  (reduce (lambda (best next-coords)
+		    (if (> (abs (turns-to-face coords starting-dir best))
+			   (abs (turns-to-face coords starting-dir next-coords)))
+			next-coords
+			best))
+		  starting-dir
+		  dest-coords-list)))
+      (bot-turn starting-dir (turns-to-face coords starting-dir best-coords))))))
+
+;; Returns a list of the coords adjacent the the given coords.
+(define (list-adjacent coords)
+  (map (lambda (c) (map + c coords))
+       directions-in-seq))
+
+;; Do as many robot-feel calls as needed to determine what is in front
+;; of the bot.
+(define (bot-feel)
+  (define (bot-feel-inner feel-for-list)
+    (cond
+     ((null? feel-for-list)
+      "prize-or-food")
+     (else
+      (let*
+	  ((starting-shields (robot-get-shields))
+	   (found (robot-feel (car feel-for-list))))
+	(if found
+	    (car feel-for-list)
+	    (if (< (robot-get-shields) starting-shields)
+		"baddie"
+		(bot-feel-inner (cdr feel-for-list))))))))
+  (bot-feel-inner
+   '("space" "wall" "robot")))
+
+(define (bot-greedy-feel)
+  (let ((felt (bot-feel)))
+    (cond
+     ((member felt '("prize-or-food" "prize" "food"))
+      (if (robot-grab)
+	  "space"
+	  felt))
+     (else felt))))
+
+(define (bot-move map-info coords direction coords-to)
+  (cond
+   ((not
+     (member coords-to (list (map + coords direction)
+			     (map - coords direction))))
+    (error
+     (format #f "bot-move: coords-to ~A is neither in front of nor behind coords ~A (direction ~A)"
+	     coords-to coords direction)))
+   ((robot-move (if (equal? (map + coords direction) coords-to)
+		    1 -1))
+    (hash-table-set! map-info coords-to
+		     (list
+		      (car (hash-table-ref/default map-info coords-to #f))
+		      'robot))
+    (hash-table-set! map-info coords
+		     (list
+		      (car (hash-table-ref/default map-info coords #f))
+		      'visited))
+    coords-to)
+   (else
+    (if (robot-is-alive?)
+	(error
+	 (format #f "bot-move: failed moving ~A (direction ~A) to ~A~%"
+		 coords direction coords-to))
+	coords))))
+
+;; If all a location's neighbors are known, then it does not need to
+;; be marked 'not-visited (i.e. no need to take the robot there).
+;; This should cascade to its unvisited neighbors.
+(define (map-info-infer! map-info initial-coords)
+  (define (coords-wall? coords)
+    (and
+     (hash-table-exists? map-info coords)
+     (equal? "wall" (car (hash-table-ref map-info coords)))))
+  (define (coords-known? coords)
+    (and (hash-table-exists? map-info coords)
+	 (string? (car (hash-table-ref map-info coords)))
+	 coords))
+  (define (map-info-infer-recur! to-check checked)
+    (cond
+     ((null? to-check) 'done)
+     (else
+      (let*
+	  ((coords (car to-check)))
+	(when
+	    (and
+	     (every coords-known? (list-adjacent coords))
+	     (not (coords-wall? coords)))
+	  (hash-table-set!
+	   map-info coords
+	   (list (car (hash-table-ref map-info coords)) 'inferred)))
+	(map-info-infer-recur!
+	 (append
+	  (cdr to-check)
+	  (filter
+	   (lambda (c)
+	     (and (hash-table-exists? map-info c)
+		  (eq? 'not-visited
+		       (cadr (hash-table-ref/default map-info c #f)))
+		  (not (coords-wall? c))
+		  (not (member c checked))))
+	   (list-adjacent coords)))
+	 (cons coords checked))))))
+  (map-info-infer-recur! (list initial-coords) '()))
+
+;;;;;;;;;;;;;;;;
+;; Dijkstra's Shortest Path Algorithm
+
+;; Use to calculate the best path for the robot to get to an
+;; interesting location.
+
+;; When there are no interesting adjacent locations, check map-info
+;; for interesting locations and go to the closest one.  Baddies
+;; should be engaged if there are no interesting spaces. They may be
+;; blocking interesting areas.
+
+;; shortest-paths produces a hash-table containing a direction-tagged
+;; (vector) and a cost.  Directions are only nort-south and east-west
+;; (it does not worry about which---assumtion is that the robot is
+;; willing to go forwards or backwards.
+
+;; Example location 2,3 facing east will have a key '(2 3 1 0) and a
+;; value of n (the cost to reach that location facing in that
+;; direction).
+(define (list-adjacent-vectors coords-vector)
+  (map (lambda (c)
+	 (append c (if (= (car c) (car coords-vector))
+		       '(0 1)
+		       '(1 0))))
+       (list-adjacent (take coords-vector 2))))
+
+(define (adjacent-move-cost coords-vector dest-coords-vector
+			    move-cost turn-cost)
+  (+ move-cost
+     (*
+      turn-cost
+      (if (equal? (drop coords-vector 2)
+		  (drop dest-coords-vector 2))
+	  0 1))))
+
+(define (shortest-paths map-coords coords dir move-cost turn-cost)
+  (let*
+      ((uncalced-dist 99999)
+       (visited (alist->hash-table (list (cons (append coords (map abs dir)) 0))))
+       (unvisited
+	(alist->hash-table
+	 (fold
+	  (lambda (c l)
+	    (alist-cons
+	     (append c '(0 1)) uncalced-dist
+	     (alist-cons (append c '(1 0)) uncalced-dist l)))
+	  '()
+	  (delete coords map-coords)))))
+    (define (iter current-coords-vector)
+      (define (calc-dist-and-set! adj-coords-vector)
+	(let*
+	    ((loc-hash (if (hash-table-exists? unvisited adj-coords-vector)
+			   unvisited visited))
+	     (new-dist (+ (adjacent-move-cost current-coords-vector
+					      adj-coords-vector
+					      move-cost turn-cost)
+			  (hash-table-ref
+			   unvisited current-coords-vector
+			   (lambda () (hash-table-ref visited current-coords-vector))))))
+	  (when (and (hash-table-exists? loc-hash adj-coords-vector)
+		     (< new-dist (hash-table-ref loc-hash adj-coords-vector)))
+	    (hash-table-set! loc-hash adj-coords-vector new-dist))))
+      (cond
+       ((zero? (hash-table-size unvisited)) visited)
+       (else
+	(for-each
+	 calc-dist-and-set!
+	 (list-adjacent-vectors current-coords-vector))
+
+	;; Move current-coords-vector from unvisited into visited
+	(hash-table-set! visited
+			 current-coords-vector
+			 (hash-table-ref
+			  unvisited current-coords-vector
+			  (lambda ()
+			    (hash-table-ref visited current-coords-vector))))
+	(hash-table-delete! unvisited current-coords-vector)))
+
+      ;; Find the next smallest cost location to continue from
+      (let
+	  ((next-coord
+	    (hash-table-fold
+	     unvisited
+	     (lambda (k v min-coords)
+	       (cond
+		((= v uncalced-dist) min-coords)
+		((< v
+		    (hash-table-ref/default unvisited min-coords uncalced-dist))
+		 k)
+		(else min-coords)))
+	     #f)))
+	(if next-coord
+	    (iter next-coord)
+	    visited)))
+    (iter (car (hash-table-keys visited)))))
+
+;;;;;;;;;;;;;;;;
+;; Shortest Path Helper Functions
+
+(define (shortest-path-distance-to sp coords)
+  (reduce min #f
+	  (filter
+	   number?
+	   (list
+	    (hash-table-ref/default sp (append coords '(1 0)) #f)
+	    (hash-table-ref/default sp (append coords '(0 1)) #f)))))
+
+(define (shortest-path-to sp coords move-cost turn-cost)
+  (define (recur path)
+    (let
+	((next
+	  (car
+	   (reduce
+	    (lambda (c l) (if (< (cdr c) (cdr l)) c l))
+	    '()
+	    (map
+	     (lambda (c)
+	       (cons c
+		     (+ (or
+			 (shortest-path-distance-to sp (take c 2))
+			 999999)
+			(adjacent-move-cost c (car path)
+					    move-cost turn-cost))))
+	     (list-adjacent-vectors (car path)))))))
+      (when (member (take next 2) path)
+	(error "shortest-path-to: cycle detected"))
+      (if (zero? (shortest-path-distance-to sp (take next 2)))
+	  path
+	  (recur (cons (take next 2) path)))))
+  (recur (list coords)))
+
+(define (shortest-path-nearest sp interesting-coords)
+  (reduce
+   (lambda (c l)
+     (if (< (shortest-path-distance-to sp c)
+	    (shortest-path-distance-to sp l))
+	 c l))
+   '()
+   interesting-coords))
+
+(define (shortest-path-to-nearest map-coords
+				  starting-coords starting-dir
+				  interesting-coords
+				  move-cost
+				  turn-cost)
+  (let
+      ((sp (shortest-paths map-coords starting-coords starting-dir move-cost turn-cost)))
+    (let
+	((next-path (shortest-path-to
+		     sp
+		     (shortest-path-nearest sp interesting-coords)
+		     move-cost
+		     turn-cost)))
+      ;; (when (< 13 (car starting-coords))
+      ;; 	(error "wtf"))
+      (list
+       (shortest-path-distance-to sp (last next-path))
+       next-path))))
+
+;;;;;;;;;;;;;;;;
+;; Bot Mainline
+
+(define (bot-main max-iter be-chatty)
+  (let
+      ((map-info (make-hash-table)))
+    (define (negate-coords-predicate p)
+      (lambda (coords)
+	(when (not (pair? coords))
+	  (error "negate-coords-predicate given a non-coords parameter ~A"
+		 coords))
+	(and (not (p coords))
+	     coords)))
+    (define (coords-known? coords)
+      (and (hash-table-exists? map-info coords)
+	   (string? (car (hash-table-ref map-info coords)))
+	   coords))
+    (define (coords-explored? coords)
+      (and
+       (hash-table-exists? map-info coords)
+       (memq (cadr (hash-table-ref map-info coords))
+	     '(visited inferred blocked))
+       coords))
+    (define (coords-space? coords)
+      (and
+       (hash-table-exists? map-info coords)
+       (equal? "space"
+	       (car
+		(hash-table-ref map-info coords)))))
+    (define (coords-baddie? coords)
+      (and
+       (hash-table-exists? map-info coords)
+       (equal? "baddie"
+	       (car
+		(hash-table-ref map-info coords)))
+       coords))
+    (define (coords-not-explored? coords)
+      ((negate-coords-predicate coords-explored?) coords))
+    (define (coords-not-explored-not-baddie? coords)
+      (and (coords-not-explored? coords)
+	   ((negate-coords-predicate coords-baddie?) coords)
+	   coords))
+    (define (coords-not-explored-baddie? coords)
+      (and (coords-not-explored? coords)
+	   (coords-baddie? coords)
+	   coords))
+    (define (coords-blocked? coords)
+      (and
+       (hash-table-exists? map-info coords)
+       (memq (cadr (hash-table-ref map-info coords))
+    	     '(blocked))
+       coords))
+    (define (bot-wander iter coords direction dest-coords)
+      (format #t "~A: coords ~A direction ~A~%" iter coords direction)
+      (when (and be-chatty (= 0 (remainder iter 20))) (map-info-print map-info))
+      (let
+	  ((facing-coords (map + coords direction))
+	   (behind-coords (map - coords direction)))
+	(cond
+	 ((not (robot-is-alive?))
+	  (format #t "Robot died~%")
+	  map-info)
+	 ((and (< 0 max-iter) (> iter max-iter)) ;; Bail out after a few iterations
+	  (format #t "Max iterations in bot-main reached (~d = ~d)~%"
+		  iter max-iter)
+	  map-info)
+
+	 ((not (coords-known? facing-coords))
+	  ;; The robot is facing a location we haven't figured out
+	  (and be-chatty (format #t "Feel ~A~%" facing-coords))
+	  (let ((felt (bot-greedy-feel)))
+	    (hash-table-set!
+	     map-info
+	     facing-coords
+	     (list felt
+		   (cond
+		    ((equal? felt "wall") 'blocked)
+		    ((equal? felt "baddie") 'not-visited)
+		    ((equal? felt "space") 'not-visited)
+		    (else 'other))))
+	    (map-info-infer! map-info facing-coords)
+	    (bot-wander (1+ iter) coords direction dest-coords)))
+
+	 ((any (lambda (c) (not (coords-known? c)))
+	       (list-adjacent coords))
+	  ;; We have more to learn about this location's neighbors
+	  (and be-chatty (format #t "Investigate neighbors of ~A~%" coords))
+	  (bot-wander (1+ iter) coords
+		      (turn-to-best
+		       coords direction
+		       (filter (lambda (c) (not (coords-known? c)))
+			       (list-adjacent coords)))
+		      dest-coords))
+
+	 ((and dest-coords
+	       (coords-baddie? dest-coords))
+	  ;; Next to a baddie to zap
+	  (and be-chatty
+	       (format #t "Next to a baddie ~A that is blocking us ~A~%"
+		   dest-coords coords))
+	  (if (not (equal? facing-coords dest-coords))
+	      (bot-wander (1+ iter) coords
+			  (turn-to-best coords direction (list dest-coords))
+			  dest-coords)
+	      (begin
+		(and be-chatty
+		     (format #t "Zapping from ~A to ~A~%" coords facing-coords))
+		(when (robot-zap)
+		  (hash-table-set! map-info
+				   facing-coords
+				   (list "space" 'not-visited)))
+		(bot-wander (1+ iter) coords direction #f))))
+
+	 ((or (coords-not-explored-not-baddie? facing-coords)
+	      (member dest-coords (list facing-coords behind-coords)))
+	  ;; Facing an un-visited, not known baddie location; move to it.
+	  (format #t "Moving ~A to ~A f ~A b ~A~%" coords
+		  (if (or (coords-not-explored-not-baddie? facing-coords)
+			 (equal? facing-coords dest-coords))
+		     facing-coords  ;; go forward
+		     behind-coords ;; go backward
+		     )
+		  facing-coords behind-coords)
+	  (bot-wander (1+ iter)
+		      (bot-move map-info coords direction
+				(or dest-coords
+				    facing-coords))
+		      direction #f))
+
+	 ((any coords-not-explored-not-baddie? (list-adjacent coords))
+	  ;; There are un-visited, not known baddie neighboring locations
+	  ;; Turn to face a location we can explore
+	  (and be-chatty
+	       (format #t "Turn to face a better location ~A~%" coords))
+	  (bot-wander (1+ iter) coords
+		      (turn-to-best
+		       coords direction
+		       (filter coords-not-explored-not-baddie?
+			       (list-adjacent coords)))
+		      dest-coords))
+	 (else
+	  (let
+	      ((interesting-coords
+	  	(filter
+	  	 coords-not-explored-not-baddie?
+	  	 (delete coords (hash-table-keys map-info))))
+	       (baddie-blocked-coords
+	  	(filter
+	  	 coords-not-explored-baddie?
+	  	 (delete coords (hash-table-keys map-info)))))
+	    (cond
+	     ((and (null? interesting-coords)
+	    	   (null? baddie-blocked-coords))
+	      (format #t "Nothing left to do ~A~%" coords)
+	      map-info)
+	     (else
+	      (let*
+	    	  ((interesting-path
+	    	    (and
+		     (not (null? interesting-coords))
+		     (shortest-path-to-nearest
+	    	      (filter
+		       coords-space?
+		       (hash-table-keys map-info))
+		      coords direction
+		      interesting-coords
+	    	      (robot-get-move-energy-cost)
+		      (robot-get-turn-energy-cost))))
+		   (baddie-blocked-path
+		    (and
+		     (not (null? baddie-blocked-coords))
+	    	     (shortest-path-to-nearest
+	    	      (append
+		       (filter
+			coords-space?
+			(hash-table-keys map-info))
+		       baddie-blocked-coords)
+		      coords direction
+		      baddie-blocked-coords
+	    	      (robot-get-move-energy-cost)
+		      (robot-get-turn-energy-cost))))
+		   (new-dest
+		    (car
+		     (second
+		      (cond
+		       ((and interesting-path
+			     baddie-blocked-path)
+			(if (< (car interesting-path)
+			       (+ (car baddie-blocked-path)
+				  (robot-get-zap-energy-cost)))
+			    interesting-path baddie-blocked-path))
+		       (interesting-path interesting-path)
+		       (baddie-blocked-path baddie-blocked-path))))))
+		(and be-chatty
+		     (format #t "Heading to ~A~%" new-dest))
+	    	(bot-wander (1+ iter) coords
+	    		    (turn-to-best
+	    		     coords direction
+	    		     (list new-dest))
+	    		    new-dest))))
+	    )
+	  ))))
+    (hash-table-set! map-info '(0 0) '("space" visited)) ;; Add the starting location
+    (bot-wander 0 (list 0 0) (list 1 0) #f)
+    (map-info-print map-info)
+    map-info))
+
+(define (bot-start)
+  (bot-main 0 #f))
+
+;; TODO: The robot currently will never reverse.  If it wants to move
+;; backwards, it should reverse instead of turning unnecessarily.
+
+(bot-start)
diff --git a/scheme/simple.scm b/scheme/simple.scm
index eccabaf..479efd1 100644
--- a/scheme/simple.scm
+++ b/scheme/simple.scm
@@ -15,7 +15,11 @@
 
 ;;; Define a function to grab all prizes
 (define (grab-all-prizes)
-  (do () (not (feel-prize)) (grab-prize)))
+  (cond
+   ((feel-prize)
+    (grab-prize)
+    (grab-all-prizes))
+   (else #f)))
 
 ;;; The program starts here: hunt for all prizes
 
diff --git a/src/Makefile.am b/src/Makefile.am
index 9373603..5f56b53 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -18,7 +18,7 @@
 bin_PROGRAMS = gnurobots
 
 AM_CFLAGS = -Wall \
-	$(GUILE_CFLAGS) $(GTK2_CFLAGS) \
+	$(GUILE_CFLAGS) $(GTK_CFLAGS) \
 	$(VTE_CFLAGS) $(GTHREAD2_CFLAGS) \
 	-I$(top_builddir)/include \
    	-DPKGLIBDIR=\"$(pkglibdir)\" \
@@ -28,6 +28,6 @@ AM_CFLAGS = -Wall \
    	-DSCRIPTS_PATH=\"$(schemedir)\"
 
 gnurobots_SOURCES = main.c api.c map.c grobot.c \
-	ui-window.c ui-cmdwin.c ui-arena.c
+	ui-window.c ui-cmdwin.c ui-arena.c ui-status.c
 gnurobots_LDFLAGS = $(GUILE_LDFLAGS) $(GTHREAD2_LIBS) \
-	$(GTK2_LIBS) $(VTE_LIBS) -lutil
+	$(GTK_LIBS) $(VTE_LIBS) -lutil
